# This macro produces the colon (':') character.
#
# Producing a specific character while dealing with key presses and scan
# codes makes it an absolute necessity to be aware of the national layout
# being used.
#
# Use this macro if your national layout places the colon (':') character
# in the Shift layer of the Z key - this applies to the following: English
# (USA) Dvorak.

  macro AUX1
    PUSH_META CLEAR_META all
    MAKE LSHIFT
    PRESS Z
    BREAK LSHIFT
    POP_ALL_META
  endmacro

# WARNING: this macro will produce the semicolon (';') instead of the colon
# character if Caps Lock is on. This is a known limitation of the Soarer's
# protocol, which does not control the state of the locks (Caps Lock, Num
# Lock and Scroll Lock).

