# CONSTANT_NAMES_MODE layer.
#
# All the mappings for this mode are defined in layer 2. For proper usage,
# CAPS LOCK IS EXPECTED TO BE OFF when this mode is activated (I would LOVE
# to be able to set, clear, push and pop its setting here!).
#
# This file should be included after the main remapblock of an .sc file,
# while the accompanying Constant-names_toggler.inc file should be included
# in the main macroblock.
#
# THIS FILE CONTAINS NATIONAL-LAYOUT-DEPENDENT MAPPINGS. Review the
# macroblock and the remapblock at the end to set the national layout you
# use.

ifselect 2
macroblock

  # Caps Lock by itself also turns CONSTANT_NAMES_MODE off. Convenient!
  macro CAPS_LOCK -all
    PRESS SELECT_2
  endmacro

  # One macro for each key in A..Z (and other letters, for those national
  # layouts with them); they are NOT triggered if Ctrl and/or Alt are
  # pressed. Shift may or may not be pressed, but its setting is ignored
  # during the execution of each macro.
  #
  # The A..Z assignment will be transparent for MOST national layouts
  # (QWERTY and QWERTZ), but French layouts will need adjustments (not for
  # the A, Z, Q and W keys, but for the M and SEMICOLON keys).

  macro A -ctrl -alt
    PUSH_META SET_META shift
    PRESS A
    POP_META
  endmacro

  macro B -ctrl -alt
    PUSH_META SET_META shift
    PRESS B
    POP_META
  endmacro

  macro C -ctrl -alt
    PUSH_META SET_META shift
    PRESS C
    POP_META
  endmacro

  macro D -ctrl -alt
    PUSH_META SET_META shift
    PRESS D
    POP_META
  endmacro

  macro E -ctrl -alt
    PUSH_META SET_META shift
    PRESS E
    POP_META
  endmacro

  macro F -ctrl -alt
    PUSH_META SET_META shift
    PRESS F
    POP_META
  endmacro

  macro G -ctrl -alt
    PUSH_META SET_META shift
    PRESS G
    POP_META
  endmacro

  macro H -ctrl -alt
    PUSH_META SET_META shift
    PRESS H
    POP_META
  endmacro

  macro I -ctrl -alt
    PUSH_META SET_META shift
    PRESS I
    POP_META
  endmacro

  macro J -ctrl -alt
    PUSH_META SET_META shift
    PRESS J
    POP_META
  endmacro

  macro K -ctrl -alt
    PUSH_META SET_META shift
    PRESS K
    POP_META
  endmacro

  macro L -ctrl -alt
    PUSH_META SET_META shift
    PRESS L
    POP_META
  endmacro

  macro M -ctrl -alt
    PUSH_META SET_META shift
    PRESS M
    POP_META
  endmacro

  macro N -ctrl -alt
    PUSH_META SET_META shift
    PRESS N
    POP_META
  endmacro

  macro O -ctrl -alt
    PUSH_META SET_META shift
    PRESS O
    POP_META
  endmacro

  macro P -ctrl -alt
    PUSH_META SET_META shift
    PRESS P
    POP_META
  endmacro

  macro Q -ctrl -alt
    PUSH_META SET_META shift
    PRESS Q
    POP_META
  endmacro

  macro R -ctrl -alt
    PUSH_META SET_META shift
    PRESS R
    POP_META
  endmacro

  macro S -ctrl -alt
    PUSH_META SET_META shift
    PRESS S
    POP_META
  endmacro

  macro T -ctrl -alt
    PUSH_META SET_META shift
    PRESS T
    POP_META
  endmacro

  macro U -ctrl -alt
    PUSH_META SET_META shift
    PRESS U
    POP_META
  endmacro

  macro V -ctrl -alt
    PUSH_META SET_META shift
    PRESS V
    POP_META
  endmacro

endblock

# Soarer's Converter is unable to handle more macros than the above in a
# single block. Fortunately, there can be more than one ifselect block for
# the same layer.

ifselect 2
macroblock

  macro W -ctrl -alt
    PUSH_META SET_META shift
    PRESS W
    POP_META
  endmacro

  macro X -ctrl -alt
    PUSH_META SET_META shift
    PRESS X
    POP_META
  endmacro

  macro Y -ctrl -alt
    PUSH_META SET_META shift
    PRESS Y
    POP_META
  endmacro

  macro Z -ctrl -alt
    PUSH_META SET_META shift
    PRESS Z
    POP_META
  endmacro

# Commented because I have chosen to "degrade" the N-tilde character to a
# simple 'N'. Uncomment this macro and comment the corresponding SEMICOLON
# line in the remapblock below to treat this letter in the same way as A-Z.
#
# # SHIFT-SEMICOLON produces N-tilde on my national layout.
# macro SEMICOLON -ctrl -alt
#   PUSH_META SET_META shift
#   PRESS SEMICOLON
#   POP_META
# endmacro

endblock


ifset any

macroblock

  # Base layer space produces an underscore.
  #
  # Producing a specific character while dealing with key presses and scan
  # codes makes it an absolute necessity to be aware of the national layout
  # being used.
  #
  # ENSURE THAT ONLY ONE "PRESS" LINE IS UNCOMMENTED, according to your
  # national layout; the supported ones are listed below.
  macro SPACE -shift -ctrl -alt
    PUSH_META CLEAR_META all
    SET_META shift
    PRESS SLASH
#   PRESS MINUS
#   PRESS QUOTE
#   PRESS 7
#   PRESS EQUAL
#   PRESS 8
    POP_META
  endmacro
  #
  # Shift-SLASH: Danish, Estonian, Faroese, German, Iberoamerican, Italian
  #              (both the 142 and 141 variants), New Italian, Norwegian,
  #              Portuguese (Portugal), Spanish (Latin America), Spanish
  #              (Spain), Swedish and Finnish, Swiss French, Swiss German,
  #              etcetera.
  # Shift-MINUS: Albanian, Canadian bilingual, English (UK), English (USA),
  #              English (USA) Colemak, Maltese (both the 48-key and 47-key
  #              variants), Portuguese (Brazil), etcetera.
  # Shift-QUOTE: English (USA) Dvorak.
  # Shift-7    : Dutch.
  # Shift-EQUAL: Icelandic, French (Belgium).
  # 8 (base)   : French (France). COMMENT OUT THE "SET_META shift" LINE.

  # Shift-space produces a regular space (for those times you want one
  # without exiting the constant names mode).
  macro SPACE shift -ctrl -alt
    PUSH_META CLEAR_META all
    PRESS SPACE
    POP_META
  endmacro

endblock

remapblock

  # Fundamental remappings.
# SPACE         (see above)


  # National-layout-dependent remappings. Uncomment the group that applies
  # to you and leave the rest commented out.

# # Danish.
# LEFT_BRACE    A           # A-ring    is degraded to a plain A.
# SEMICOLON     A           # AE lig.   is degraded to a plain A.
# QUOTE         O           # O-stroke  is degraded to a plain O.
# # TODO: add a macro to degrade AE lig. to "AE"; disable the dead keys.

# # German.
# LEFT_BRACE    U           # U-umlaut  is degraded to a plain U.
# SEMICOLON     O           # O-umlaut  is degraded to a plain O.
# QUOTE         A           # A-umlaut  is degraded to a plain A.
# # TODO: add a macro to degrade eszett to "SS"; disable the dead keys.

  # Iberoamerican, Spanish (Spain).
  SEMICOLON     N           # N-tilde   is degraded to a plain N.
  LEFT_BRACE    UNASSIGNED  # Grave and circumflex accents are turned off.
  QUOTE         UNASSIGNED  # Acute accent and diaeresis are turned off.

# # Portuguese (Brazil)
# SEMICOLON     C           # C-cedilla is degraded to a plain C.
# LEFT_BRACE    UNASSIGNED  # Acute and grave accents are turned off.
# QUOTE         UNASSIGNED  # Tilde and circumflex accents are turned off.

# # Portuguese (Portugal)
# SEMICOLON     C           # C-cedilla is degraded to a plain C.
# RIGHT_BRACE   UNASSIGNED  # Acute and grave accents are turned off.
# BACKSLASH     UNASSIGNED  # Tilde and circumflex accents are turned off.

# # Spanish (Latin America).
# SEMICOLON     N           # N-tilde   is degraded to a plain N.
# LEFT_BRACE    UNASSIGNED  # Acute accent and diaeresis are turned off.

# TODO: a bunch of other national layouts.

endblock

