# This macro produces the equals sign ('=') character.
#
# Producing a specific character while dealing with key presses and scan
# codes makes it an absolute necessity to be aware of the national layout
# being used.
#
# Use this macro if your national layout places the equals sign ('=')
# character in the base layer of the EQUAL key (the last key before
# BACKSPACE in a normal keyboard) - this applies to the following:
# Albanian, Canadian bilingual, English (UK), English (USA), English (USA)
# Colemak, French (France), Maltese (both the 48-key and 47-key variants),
# Portuguese (Brazil), etcetera.

  macro PAD_EQUALS
    PUSH_META CLEAR_META all
    PRESS EQUAL
    POP_ALL_META
  endmacro

