# Soarer Converter's configuration for PC (as opposed to terminal) IBM
# Model M keyboards (P/Ns 1388032, 1390120, 1390131, 1391401, 1391403,
# 1391506, 71G4644, 42H1292, etcetera).
#
# This configuration is equally applicable to ISO and ANSI keyboards, and
# with any regular national layout laid on top.
#
# Additions:
# - Volume controls on Caps Lock.
# - Print Screen enhancements.
# - Tailored numpad.
# - CONSTANT_NAMES_MODE.
#
# Author:  Miguel Farah.
# Date:    20200919.
# Version: 1.0.
# See:     http://www.farah.cl/SoarersConverterConfigFiles/
#
##### BEGIN ########

macroblock

include "Volume-CapsLock.inc"

include "PrtScr-enhancements.inc"

include "Constant-names_toggler.inc"

  # Num Lock needs to be available, but doesn't deserve an assignment in
  # the base layer.
  macro SCROLL_LOCK shift -ctrl -alt
    PUSH_META CLEAR_META shift
    PRESS NUM_LOCK
    POP_META
  endmacro

  # The macro that produces the equals sign is defined here. Keep ONE of
  # those entries active and the others commented out, IN ACCORDANCE WITH
  # THE NATIONAL LAYOUT BEING USED (or make a new .inc, if the need should
  # arise). Each .inc file lists the national layouts it's fit for.
# include "Equals-Belgian.inc"
# include "Equals-Dutch.inc"
# include "Equals-English-Dvorak.inc"
# include "Equals-English.inc"
  include "Equals-European.inc"

endblock


remapblock

# Numpad.
  NUM_LOCK      PAD_EQUALS  # Equals sign - see the (included) macro above.

endblock


include "Constant-names_layer.inc"

##### END ##########

